diff --git a/contrib/gmm/gmm_lapack_interface.h b/contrib/gmm/gmm_lapack_interface.h
index ea5edb4500..37bc48f5c0 100644
--- a/contrib/gmm/gmm_lapack_interface.h
+++ b/contrib/gmm/gmm_lapack_interface.h
@@ -1,32 +1,33 @@
-// -*- c++ -*- (enables emacs c++ mode)
-//===========================================================================
-//
-// Copyright (C) 2003-2008 Yves Renard
-//
-// This file is a part of GETFEM++
-//
-// Getfem++  is  free software;  you  can  redistribute  it  and/or modify it
-// under  the  terms  of the  GNU  Lesser General Public License as published
-// by  the  Free Software Foundation;  either version 2.1 of the License,  or
-// (at your option) any later version.
-// This program  is  distributed  in  the  hope  that it will be useful,  but
-// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
-// or  FITNESS  FOR  A PARTICULAR PURPOSE.  See the GNU Lesser General Public
-// License for more details.
-// You  should  have received a copy of the GNU Lesser General Public License
-// along  with  this program;  if not, write to the Free Software Foundation,
-// Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.
-//
-// As a special exception, you may use this file as part of a free software
-// library without restriction.  Specifically, if other files instantiate
-// templates or use macros or inline functions from this file, or you compile
-// this file and link it with other files to produce an executable, this
-// file does not by itself cause the resulting executable to be covered by
-// the GNU General Public License.  This exception does not however
-// invalidate any other reasons why the executable file might be covered by
-// the GNU General Public License.
-//
-//===========================================================================
+/* -*- c++ -*- (enables emacs c++ mode) */
+/*===========================================================================
+
+ Copyright (C) 2003-2020 Yves Renard
+
+ This file is a part of GetFEM
+
+ GetFEM  is  free software;  you  can  redistribute  it  and/or modify it
+ under  the  terms  of the  GNU  Lesser General Public License as published
+ by  the  Free Software Foundation;  either version 3 of the License,  or
+ (at your option) any later version along with the GCC Runtime Library
+ Exception either version 3.1 or (at your option) any later version.
+ This program  is  distributed  in  the  hope  that it will be useful,  but
+ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+ or  FITNESS  FOR  A PARTICULAR PURPOSE.  See the GNU Lesser General Public
+ License and GCC Runtime Library Exception for more details.
+ You  should  have received a copy of the GNU Lesser General Public License
+ along  with  this program;  if not, write to the Free Software Foundation,
+ Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.
+
+ As a special exception, you  may use  this file  as it is a part of a free
+ software  library  without  restriction.  Specifically,  if   other  files
+ instantiate  templates  or  use macros or inline functions from this file,
+ or  you compile this  file  and  link  it  with other files  to produce an
+ executable, this file  does  not  by itself cause the resulting executable
+ to be covered  by the GNU Lesser General Public License.  This   exception
+ does not  however  invalidate  any  other  reasons why the executable file
+ might be covered by the GNU Lesser General Public License.
+
+===========================================================================*/
 
 /**@file gmm_lapack_interface.h
    @author  Yves Renard <Yves.Renard@insa-lyon.fr>
@@ -34,8 +35,6 @@
    @brief gmm interface for LAPACK
 */
 
-#if defined(GMM_USES_LAPACK) || defined(GMM_USES_ATLAS)
-
 #ifndef GMM_LAPACK_INTERFACE_H
 #define GMM_LAPACK_INTERFACE_H
 
@@ -44,35 +43,46 @@
 #include "gmm_dense_qr.h"
 
 
+#if defined(GMM_USES_LAPACK)
+
 namespace gmm {
 
-  /* ********************************************************************* */
-  /* Operations interfaced for T = float, double, std::complex<float>      */
-  /*    or std::complex<double> :                                          */
-  /*                                                                       */
-  /* lu_factor(dense_matrix<T>, std::vector<int>)                          */
-  /* lu_solve(dense_matrix<T>, std::vector<T>, std::vector<T>)             */
-  /* lu_solve(dense_matrix<T>, std::vector<int>, std::vector<T>,           */
-  /*          std::vector<T>)                                              */
-  /* lu_solve_transposed(dense_matrix<T>, std::vector<int>, std::vector<T>,*/
-  /*          std::vector<T>)                                              */
-  /* lu_inverse(dense_matrix<T>)                                           */
-  /* lu_inverse(dense_matrix<T>, std::vector<int>, dense_matrix<T>)        */
-  /*                                                                       */
-  /* qr_factor(dense_matrix<T>, dense_matrix<T>, dense_matrix<T>)          */
-  /*                                                                       */
-  /* implicit_qr_algorithm(dense_matrix<T>, std::vector<T>)                */
-  /* implicit_qr_algorithm(dense_matrix<T>, std::vector<T>,                */
-  /*                       dense_matrix<T>)                                */
-  /* implicit_qr_algorithm(dense_matrix<T>, std::vector<std::complex<T> >) */
-  /* implicit_qr_algorithm(dense_matrix<T>, std::vector<std::complex<T> >, */
-  /*                       dense_matrix<T>)                                */
-  /*                                                                       */
-  /* ********************************************************************* */
-
-  /* ********************************************************************* */
-  /* LAPACK functions used.                                                */
-  /* ********************************************************************* */
+  /* ********************************************************************** */
+  /* Operations interfaced for T = float, double, std::complex<float>       */
+  /*    or std::complex<double> :                                           */
+  /*                                                                        */
+  /* lu_factor(dense_matrix<T>, std::vector<long>)                          */
+  /* lu_solve(dense_matrix<T>, std::vector<T>, std::vector<T>)              */
+  /* lu_solve(dense_matrix<T>, std::vector<long>, std::vector<T>,           */
+  /*          std::vector<T>)                                               */
+  /* lu_solve_transposed(dense_matrix<T>, std::vector<long>, std::vector<T>,*/
+  /*          std::vector<T>)                                               */
+  /* lu_inverse(dense_matrix<T>)                                            */
+  /* lu_inverse(dense_matrix<T>, std::vector<long>, dense_matrix<T>)        */
+  /*                                                                        */
+  /* qr_factor(dense_matrix<T>, dense_matrix<T>, dense_matrix<T>)           */
+  /*                                                                        */
+  /* implicit_qr_algorithm(dense_matrix<T>, std::vector<T>)                 */
+  /* implicit_qr_algorithm(dense_matrix<T>, std::vector<T>,                 */
+  /*                       dense_matrix<T>)                                 */
+  /* implicit_qr_algorithm(dense_matrix<T>, std::vector<std::complex<T> >)  */
+  /* implicit_qr_algorithm(dense_matrix<T>, std::vector<std::complex<T> >,  */
+  /*                       dense_matrix<T>)                                 */
+  /*                                                                        */
+  /* geev_interface_right                                                   */
+  /* geev_interface_left                                                    */
+  /*                                                                        */
+  /* schur(dense_matrix<T>, dense_matrix<T>, dense_matrix<T>)               */
+  /*                                                                        */
+  /* svd(dense_matrix<T>, dense_matrix<T>, dense_matrix<T>, std::vector<T>) */
+  /* svd(dense_matrix<T>, dense_matrix<T>, dense_matrix<T>,                 */
+  /*     std::vector<std::complex<T> >)                                     */
+  /*                                                                        */
+  /* ********************************************************************** */
+
+  /* ********************************************************************** */
+  /* LAPACK functions used.                                                 */
+  /* ********************************************************************** */
 
   extern "C" {
     void sgetrf_(...); void dgetrf_(...); void cgetrf_(...); void zgetrf_(...);
@@ -83,18 +93,25 @@ namespace gmm {
     void sormqr_(...); void dormqr_(...); void cunmqr_(...); void zunmqr_(...);
     void sgees_ (...); void dgees_ (...); void cgees_ (...); void zgees_ (...);
     void sgeev_ (...); void dgeev_ (...); void cgeev_ (...); void zgeev_ (...);
+    void sgeesx_(...); void dgeesx_(...); void cgeesx_(...); void zgeesx_(...);
+    void sgesvd_(...); void dgesvd_(...); void cgesvd_(...); void zgesvd_(...);
   }
-
-  /* ********************************************************************* */
-  /* LU decomposition.                                                     */
-  /* ********************************************************************* */
-
-# define getrf_interface(lapack_name, base_type) inline                    \
-  size_type lu_factor(dense_matrix<base_type > &A, std::vector<int> &ipvt){\
-    GMMLAPACK_TRACE("getrf_interface");                                    \
-    int m(mat_nrows(A)), n(mat_ncols(A)), lda(m), info(0);                 \
-    if (m && n) lapack_name(&m, &n, &A(0,0), &lda, &ipvt[0], &info);       \
-    return size_type(info);                                                \
+  
+  /* ********************************************************************** */
+  /* LU decomposition.                                                      */
+  /* ********************************************************************** */
+  
+# define getrf_interface(lapack_name, base_type) inline                      \
+    size_type lu_factor(dense_matrix<base_type > &A, lapack_ipvt &ipvt){     \
+    GMMLAPACK_TRACE("getrf_interface");                                      \
+    BLAS_INT m = BLAS_INT(mat_nrows(A)), n = BLAS_INT(mat_ncols(A)), lda(m); \
+    long info(-1L);                                                          \
+    if (m && n) lapack_name(&m, &n, &A(0,0), &lda, ipvt.pfirst(), &info);    \
+    if ((sizeof(BLAS_INT) == 4) ||                                            \
+        ((info & 0xFFFFFFFF00000000L) && !(info & 0x00000000FFFFFFFFL)))     \
+      /* For compatibility with lapack version with 32 bit integer. */	     \
+      ipvt.set_to_int32();						     \
+    return size_type(int(info & 0x00000000FFFFFFFFL));			     \
   }
 
   getrf_interface(sgetrf_, BLAS_S)
@@ -108,13 +125,13 @@ namespace gmm {
 
 # define getrs_interface(f_name, trans1, lapack_name, base_type) inline    \
   void f_name(const dense_matrix<base_type > &A,                           \
-	      const std::vector<int> &ipvt, std::vector<base_type > &x,    \
-	      const std::vector<base_type > &b) {                          \
+              const lapack_ipvt &ipvt, std::vector<base_type > &x,	   \
+              const std::vector<base_type > &b) {                          \
     GMMLAPACK_TRACE("getrs_interface");                                    \
-    int n(mat_nrows(A)), info, nrhs(1);                                    \
+    BLAS_INT n = BLAS_INT(mat_nrows(A)), info(0), nrhs(1);                 \
     gmm::copy(b, x); trans1;                                               \
     if (n)                                                                 \
-      lapack_name(&t, &n, &nrhs, &(A(0,0)),&n,&ipvt[0], &x[0], &n, &info); \
+      lapack_name(&t,&n,&nrhs,&(A(0,0)),&n,ipvt.pfirst(),&x[0],&n,&info);  \
   }
   
 # define getrs_trans_n const char t = 'N'
@@ -135,17 +152,18 @@ namespace gmm {
 
 # define getri_interface(lapack_name, base_type) inline                    \
   void lu_inverse(const dense_matrix<base_type > &LU,                      \
-       std::vector<int> &ipvt, const dense_matrix<base_type > &A_) {       \
+	    const lapack_ipvt &ipvt, const dense_matrix<base_type > &A_) { \
     GMMLAPACK_TRACE("getri_interface");                                    \
     dense_matrix<base_type >&                                              \
     A = const_cast<dense_matrix<base_type > &>(A_);                        \
-    int n(mat_nrows(A)), info, lwork(-1); base_type work1;                 \
+    BLAS_INT n = BLAS_INT(mat_nrows(A)), info(0), lwork(-1);               \
+    base_type work1;                                                       \
     if (n) {                                                               \
       gmm::copy(LU, A);                                                    \
-      lapack_name(&n, &A(0,0), &n, &ipvt[0], &work1, &lwork, &info);       \
+      lapack_name(&n, &A(0,0), &n, ipvt.pfirst(), &work1, &lwork, &info);  \
       lwork = int(gmm::real(work1));                                       \
-      std::vector<base_type > work(lwork);                                 \
-      lapack_name(&n, &A(0,0), &n, &ipvt[0], &work[0], &lwork, &info);     \
+      std::vector<base_type> work(lwork);                                  \
+      lapack_name(&n, &A(0,0), &n, ipvt.pfirst(), &work[0], &lwork,&info); \
     }                                                                      \
   }
 
@@ -154,23 +172,24 @@ namespace gmm {
   getri_interface(cgetri_, BLAS_C)
   getri_interface(zgetri_, BLAS_Z)
 
+  /* ********************************************************************** */
+  /* QR factorization.                                                      */
+  /* ********************************************************************** */
 
-  /* ********************************************************************* */
-  /* QR factorization.                                                     */
-  /* ********************************************************************* */
-
-# define geqrf_interface(lapack_name1, base_type) inline		   \
-  void qr_factor(dense_matrix<base_type > &A){			           \
-    GMMLAPACK_TRACE("geqrf_interface");				           \
-    int m(mat_nrows(A)), n(mat_ncols(A)), info, lwork(-1); base_type work1;\
-    if (m && n) {							   \
-      std::vector<base_type > tau(n);					   \
+# define geqrf_interface(lapack_name1, base_type) inline                   \
+  void qr_factor(dense_matrix<base_type > &A){                             \
+    GMMLAPACK_TRACE("geqrf_interface");                                    \
+    BLAS_INT m = BLAS_INT(mat_nrows(A)), n=BLAS_INT(mat_ncols(A));         \
+    BLAS_INT info(0), lwork(-1);                                           \
+    base_type work1;                                                       \
+    if (m && n) {                                                          \
+      std::vector<base_type > tau(n);                                      \
       lapack_name1(&m, &n, &A(0,0), &m, &tau[0], &work1  , &lwork, &info); \
-      lwork = int(gmm::real(work1));					   \
-      std::vector<base_type > work(lwork);				   \
+      lwork = BLAS_INT(gmm::real(work1));                                  \
+      std::vector<base_type > work(lwork);                                 \
       lapack_name1(&m, &n, &A(0,0), &m, &tau[0], &work[0], &lwork, &info); \
-      GMM_ASSERT1(!info, "QR factorization failed");			   \
-    }									   \
+      GMM_ASSERT1(!info, "QR factorization failed");                       \
+    }                                                                      \
   }
     
   geqrf_interface(sgeqrf_, BLAS_S)
@@ -184,18 +203,20 @@ namespace gmm {
   void qr_factor(const dense_matrix<base_type > &A,                        \
        dense_matrix<base_type > &Q, dense_matrix<base_type > &R) {         \
     GMMLAPACK_TRACE("geqrf_interface2");                                   \
-    int m(mat_nrows(A)), n(mat_ncols(A)), info, lwork(-1); base_type work1;\
-    if (m && n) {                                                          \
-      gmm::copy(A, Q);                                                     \
+    BLAS_INT m = BLAS_INT(mat_nrows(A)), n=BLAS_INT(mat_ncols(A));         \
+    BLAS_INT info(0), lwork(-1);                                           \
+    base_type work1;                                                       \
+    if (m && n) {							   \
+      std::copy(A.begin(), A.end(), Q.begin());				   \
       std::vector<base_type > tau(n);                                      \
       lapack_name1(&m, &n, &Q(0,0), &m, &tau[0], &work1  , &lwork, &info); \
-      lwork = int(gmm::real(work1));                                       \
+      lwork = BLAS_INT(gmm::real(work1));                                  \
       std::vector<base_type > work(lwork);                                 \
       lapack_name1(&m, &n, &Q(0,0), &m, &tau[0], &work[0], &lwork, &info); \
       GMM_ASSERT1(!info, "QR factorization failed");                       \
       base_type *p = &R(0,0), *q = &Q(0,0);                                \
-      for (int j = 0; j < n; ++j, q += m-n)                                \
-        for (int i = 0; i < n; ++i, ++p, ++q)                              \
+      for (BLAS_INT j = 0; j < n; ++j, q += m-n)                           \
+        for (BLAS_INT i = 0; i < n; ++i, ++p, ++q)                         \
           *p = (j < i) ? base_type(0) : *q;                                \
       lapack_name2(&m, &n, &n, &Q(0,0), &m,&tau[0],&work[0],&lwork,&info); \
     }                                                                      \
@@ -207,9 +228,9 @@ namespace gmm {
   geqrf_interface2(cgeqrf_, cungqr_, BLAS_C)
   geqrf_interface2(zgeqrf_, zungqr_, BLAS_Z)
   
-  /* ********************************************************************* */
-  /* QR algorithm for eigenvalues search.                                  */
-  /* ********************************************************************* */
+  /* ********************************************************************** */
+  /* QR algorithm for eigenvalues search.                                   */
+  /* ********************************************************************** */
 
 # define gees_interface(lapack_name, base_type)                            \
   template <typename VECT> inline void implicit_qr_algorithm(              \
@@ -218,17 +239,18 @@ namespace gmm {
          double tol=gmm::default_tol(base_type()), bool compvect = true) { \
     GMMLAPACK_TRACE("gees_interface");                                     \
     typedef bool (*L_fp)(...);  L_fp p = 0;                                \
-    int n(mat_nrows(A)), info, lwork(-1), sdim; base_type work1;           \
+    BLAS_INT n=BLAS_INT(mat_nrows(A)), info(0), lwork(-1), sdim;           \
+    base_type work1;                                                       \
     if (!n) return;                                                        \
     dense_matrix<base_type > H(n,n); gmm::copy(A, H);                      \
     char jobvs = (compvect ? 'V' : 'N'), sort = 'N';                       \
     std::vector<double> rwork(n), eigv1(n), eigv2(n);                      \
     lapack_name(&jobvs, &sort, p, &n, &H(0,0), &n, &sdim, &eigv1[0],       \
                 &eigv2[0], &Q(0,0), &n, &work1, &lwork, &rwork[0], &info); \
-    lwork = int(gmm::real(work1));                                         \
+    lwork = BLAS_INT(gmm::real(work1));                                    \
     std::vector<base_type > work(lwork);                                   \
     lapack_name(&jobvs, &sort, p, &n, &H(0,0), &n, &sdim, &eigv1[0],       \
-		&eigv2[0], &Q(0,0), &n, &work[0], &lwork, &rwork[0],&info);\
+                &eigv2[0], &Q(0,0), &n, &work[0], &lwork, &rwork[0],&info);\
     GMM_ASSERT1(!info, "QR algorithm failed");                             \
     extract_eig(H, const_cast<VECT &>(eigval_), tol);                      \
   }
@@ -240,14 +262,15 @@ namespace gmm {
          double tol=gmm::default_tol(base_type()), bool compvect = true) { \
     GMMLAPACK_TRACE("gees_interface2");                                    \
     typedef bool (*L_fp)(...);  L_fp p = 0;                                \
-    int n(mat_nrows(A)), info, lwork(-1), sdim; base_type work1;           \
+    BLAS_INT n=BLAS_INT(mat_nrows(A)), info(0), lwork(-1), sdim;           \
+    base_type work1;                                                       \
     if (!n) return;                                                        \
     dense_matrix<base_type > H(n,n); gmm::copy(A, H);                      \
     char jobvs = (compvect ? 'V' : 'N'), sort = 'N';                       \
     std::vector<double> rwork(n), eigvv(n*2);                              \
     lapack_name(&jobvs, &sort, p, &n, &H(0,0), &n, &sdim, &eigvv[0],       \
                 &Q(0,0), &n, &work1, &lwork, &rwork[0], &rwork[0], &info); \
-    lwork = int(gmm::real(work1));                                         \
+    lwork = BLAS_INT(gmm::real(work1));                                    \
     std::vector<base_type > work(lwork);                                   \
     lapack_name(&jobvs, &sort, p, &n, &H(0,0), &n, &sdim, &eigvv[0],       \
                 &Q(0,0), &n, &work[0], &lwork, &rwork[0], &rwork[0],&info);\
